
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android的服务（Service）（二）Service的自动重启问题 / 憋错料</title>

    <meta name="description" content="Android的服务（Service）（二）Service的自动重启问题 继续上篇的分析,接下来是第二个问题&quot;Service的自动重启问题&quot; (一).Service的生命周期 (二).Service的自动重启问题 这里要说服务的自动重启问题,这个问题其实很简单,只有两个关键的方法.代码如下: 这个方法在ActivityThread的一系列针对服务的handle方法中都有调用到ActivityManagerSerice的serviceDoneExecuting()方法,但是跟重启有关的只有handleServiceArgs(),因为只有在这里才有一个 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android的服务（Service）（二）Service的自动重启问题</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>继续上篇的分析，接下来是第二个问题”Service的自动重启问题“</p>
<p>（一）、Service的生命周期</p>
<p>（二）、Service的自动重启问题</p>
<p>这里要说服务的自动重启问题，这个问题其实很简单，只有两个关键的方法。代码如下：</p>
<p>这个方法在ActivityThread的一系列针对服务的handle方法中都有调用到ActivityManagerSerice的serviceDoneExecuting()方法，但是跟重启有关的只有handleServiceArgs()，因为只有在这里才有一个叫res的参数会起作用。</p>
<pre>    private void handleServiceArgs(ServiceArgsData data) {
        Service s = mServices.get(data.token);
        if (s != null) {
            try {
                if (data.args != null) {
                    data.args.setExtrasClassLoader(s.getClassLoader());
                }
                int res;
                if (!data.taskRemoved) {
                    //就是回调了用户服务的onStartCommand生命周期，这个做应用的都知道了，

                    //这里可以通过设置其返回值来控制自己的服务是否允许被重新启动，顺理成章的这个值就是res
                    res = s.onStartCommand(data.args, data.flags, data.startId);
                } else {
                    s.onTaskRemoved(data.args);
                    res = Service.START_TASK_REMOVED_COMPLETE;
                }
                ...............
                try {
                    //看看系统用这个值都干了一些什么导致有这个特性
                    ActivityManagerNative.getDefault().serviceDoneExecuting(
                            data.token, 1, data.startId, res);
                } catch (RemoteException e) {
                    // nothing to do.
                }
                ensureJitEnabled();
            }
            ..................
        }
    }</pre>
<p>下面就是这个特性的关键代码，里面的注释已经写的很全了，关键其作用的就是stopIfKilled这个标志。</p>
<pre>    void serviceDoneExecutingLocked(ServiceRecord r, int type, int startId, int res) {
        boolean inDestroying = mDestroyingServices.contains(r);
        if (r != null) {
            if (type == 1) {
                // This is a call from a service start...  take care of
                // book-keeping.
                r.callStart = true;
                switch (res) {
                    case Service.START_STICKY_COMPATIBILITY:
                    case Service.START_STICKY: {
                        // We are done with the associated start arguments.
                        r.findDeliveredStart(startId, true);
                        // Don&#039;t stop if killed.
                        r.stopIfKilled = false;
                        break;
                    }
                    case Service.START_NOT_STICKY: {
                        // We are done with the associated start arguments.
                        r.findDeliveredStart(startId, true);
                        if (r.getLastStartId() == startId) {
                            // There is no more work, and this service
                            // doesn&#039;t want to hang around if killed.
                            r.stopIfKilled = true;
                        }
                        break;
                    }
                    case Service.START_REDELIVER_INTENT: {
                        // We&#039;ll keep this item until they explicitly
                        // call stop for it, but keep track of the fact
                        // that it was delivered.
                        ServiceRecord.StartItem si = r.findDeliveredStart(startId, false);
                        if (si != null) {
                            si.deliveryCount = 0;
                            si.doneExecutingCount++;
                            // Don&#039;t stop if killed.
                            r.stopIfKilled = true;
                        }
                        break;
                    }
                    case Service.START_TASK_REMOVED_COMPLETE: {
                        // Special processing for onTaskRemoved().  Don&#039;t
                        // impact normal onStartCommand() processing.
                        r.findDeliveredStart(startId, true);
                        break;
                    }
                    default:
                        throw new IllegalArgumentException(
                                &quot;Unknown service start result: &quot; + res);
                }
                if (res == Service.START_STICKY_COMPATIBILITY) {
                    r.callStart = false;
                }
            }
            final long origId = Binder.clearCallingIdentity();
            serviceDoneExecutingLocked(r, inDestroying, inDestroying);
            Binder.restoreCallingIdentity(origId);
        } else {
            Slog.w(TAG, &quot;Done executing unknown service from pid &quot;
                    + Binder.getCallingPid());
        }
    }</pre>
<p>那么这个标志位又是在哪些情况下使得服务可以重启的呢？这种场景入口很多啊，比如系统清理进程等，总之就是APP Died的情况下，入口方法不列举了，最后都会执行到这来：</p>
<pre>    final void killServicesLocked(ProcessRecord app, boolean allowRestart) {
        // Report disconnected services.
        if (false) {
            // XXX we are letting the client link to the service for
            // death notifications.
            if (app.services.size() &gt; 0) {
                Iterator&lt;ServiceRecord&gt; it = app.services.iterator();
                while (it.hasNext()) {
                    ServiceRecord r = it.next();
                    for (int conni=r.connections.size()-1; conni&gt;=0; conni--) {
                        ArrayList&lt;ConnectionRecord&gt; cl = r.connections.valueAt(conni);
                        for (int i=0; i&lt;cl.size(); i++) {
                            ConnectionRecord c = cl.get(i);
                            if (c.binding.client != app) {
                                try {
                                    //c.conn.connected(r.className, null);
                                } catch (Exception e) {
                                    // todo: this should be asynchronous!
                                    Slog.w(TAG, &quot;Exception thrown disconnected servce &quot;
                                          + r.shortName
                                          + &quot; from app &quot; + app.processName, e);
                                }
                            }
                        }
                    }
                }
            }
        }

        // First clear app state from services.
        for (int i=app.services.size()-1; i&gt;=0; i--) {
            ServiceRecord sr = app.services.valueAt(i);
            synchronized (sr.stats.getBatteryStats()) {
                sr.stats.stopLaunchedLocked();
            }
            if (sr.app != null) {
                sr.app.services.remove(sr);
            }
            sr.app = null;
            sr.isolatedProc = null;
            sr.executeNesting = 0;
            sr.forceClearTracker();
            if (mDestroyingServices.remove(sr)) {
                if (DEBUG_SERVICE) Slog.v(TAG, &quot;killServices remove destroying &quot; + sr);
            }

            final int numClients = sr.bindings.size();
            for (int bindingi=numClients-1; bindingi&gt;=0; bindingi--) {
                IntentBindRecord b = sr.bindings.valueAt(bindingi);
                if (DEBUG_SERVICE) Slog.v(TAG, &quot;Killing binding &quot; + b
                        + &quot;: shouldUnbind=&quot; + b.hasBound);
                b.binder = null;
                b.requested = b.received = b.hasBound = false;
            }
        }

        // Clean up any connections this application has to other services.
        for (int i=app.connections.size()-1; i&gt;=0; i--) {
            ConnectionRecord r = app.connections.valueAt(i);
            removeConnectionLocked(r, app, null);
        }
        app.connections.clear();

        ServiceMap smap = getServiceMap(app.userId);

        // Now do remaining service cleanup.
        for (int i=app.services.size()-1; i&gt;=0; i--) {
            ServiceRecord sr = app.services.valueAt(i);
            // Sanity check: if the service listed for the app is not one
            // we actually are maintaining, drop it.
            if (smap.mServicesByName.get(sr.name) != sr) {
                ServiceRecord cur = smap.mServicesByName.get(sr.name);
                Slog.wtf(TAG, &quot;Service &quot; + sr + &quot; in process &quot; + app
                        + &quot; not same as in map: &quot; + cur);
                app.services.removeAt(i);
                continue;
            }

            // Any services running in the application may need to be placed
            // back in the pending list.
            // 这里还是分很多种情况的
            // 允许重启时，如果当前服务所在进程crash超过两次，并且不是persistent的进程就结束不会重启了
            if (allowRestart &amp;&amp; sr.crashCount &gt;= 2 &amp;&amp; (sr.serviceInfo.applicationInfo.flags
                    &amp;ApplicationInfo.FLAG_PERSISTENT) == 0) {
                Slog.w(TAG, &quot;Service crashed &quot; + sr.crashCount
                        + &quot; times, stopping: &quot; + sr);
                EventLog.writeEvent(EventLogTags.AM_SERVICE_CRASHED_TOO_MUCH,
                        sr.userId, sr.crashCount, sr.shortName, app.pid);
                bringDownServiceLocked(sr);
            } else if (!allowRestart) {
                // 不允许重启直接挂掉
                bringDownServiceLocked(sr);
            } else {
                //
                boolean canceled = scheduleServiceRestartLocked(sr, true);

                // Should the service remain running?  Note that in the
                // extreme case of so many attempts to deliver a command
                // that it failed we also will stop it here.
                if (sr.startRequested &amp;&amp; (sr.stopIfKilled || canceled)) {
                    if (sr.pendingStarts.size() == 0) {
                        sr.startRequested = false;
                        if (sr.tracker != null) {
                            sr.tracker.setStarted(false, mAm.mProcessStats.getMemFactorLocked(),
                                    SystemClock.uptimeMillis());
                        }
                        if (!sr.hasAutoCreateConnections()) {
                            // Whoops, no reason to restart!
                            bringDownServiceLocked(sr);
                        }
                    }
                }
            }
        }

        if (!allowRestart) {
            app.services.clear();

            // Make sure there are no more restarting services for this process.
            for (int i=mRestartingServices.size()-1; i&gt;=0; i--) {
                ServiceRecord r = mRestartingServices.get(i);
                if (r.processName.equals(app.processName) &amp;&amp;
                        r.serviceInfo.applicationInfo.uid == app.info.uid) {
                    mRestartingServices.remove(i);
                    clearRestartingIfNeededLocked(r);
                }
            }
            for (int i=mPendingServices.size()-1; i&gt;=0; i--) {
                ServiceRecord r = mPendingServices.get(i);
                if (r.processName.equals(app.processName) &amp;&amp;
                        r.serviceInfo.applicationInfo.uid == app.info.uid) {
                    mPendingServices.remove(i);
                }
            }
        }

        // Make sure we have no more records on the stopping list.
        int i = mDestroyingServices.size();
        while (i &gt; 0) {
            i--;
            ServiceRecord sr = mDestroyingServices.get(i);
            if (sr.app == app) {
                sr.forceClearTracker();
                mDestroyingServices.remove(i);
                if (DEBUG_SERVICE) Slog.v(TAG, &quot;killServices remove destroying &quot; + sr);
            }
        }

        app.executingServices.clear();
    }&#160;&#160;
</pre>
<pre>    private final boolean scheduleServiceRestartLocked(ServiceRecord r,
            boolean allowCancel) {
        boolean canceled = false;

        ServiceMap smap = getServiceMap(r.userId);
        if (smap.mServicesByName.get(r.name) != r) {
            ServiceRecord cur = smap.mServicesByName.get(r.name);
            Slog.wtf(TAG, &quot;Attempting to schedule restart of &quot; + r
                    + &quot; when found in map: &quot; + cur);
            return false;
        }

        final long now = SystemClock.uptimeMillis();

        if ((r.serviceInfo.applicationInfo.flags
                &amp;ApplicationInfo.FLAG_PERSISTENT) == 0) {
            long minDuration = SERVICE_RESTART_DURATION;
            long resetTime = SERVICE_RESET_RUN_DURATION;

            // Any delivered but not yet finished starts should be put back
            // on the pending list.
            final int N = r.deliveredStarts.size();
            if (N &gt; 0) {
                for (int i=N-1; i&gt;=0; i--) {
                    ServiceRecord.StartItem si = r.deliveredStarts.get(i);
                    si.removeUriPermissionsLocked();
                    //注意了，这里的canceled如果为true还是需要结束服务的
                    //还要关注一下delivery的上限和doneExecuting的上限
                    if (si.intent == null) {
                        // We&#039;ll generate this again if needed.
                    } else if (!allowCancel || (si.deliveryCount &lt; ServiceRecord.MAX_DELIVERY_COUNT
                            &amp;&amp; si.doneExecutingCount &lt; ServiceRecord.MAX_DONE_EXECUTING_COUNT)) {
                        //重新在pendingStart中添加si，所以会在下次执行时重新带入intent进去
                        r.pendingStarts.add(0, si);
                        long dur = SystemClock.uptimeMillis() - si.deliveredTime;
                        dur *= 2;
                        if (minDuration &lt; dur) minDuration = dur;
                        if (resetTime &lt; dur) resetTime = dur;
                    } else {
                        Slog.w(TAG, &quot;Canceling start item &quot; + si.intent + &quot; in service &quot;
                                + r.name);
                        canceled = true;
                    }
                }
                r.deliveredStarts.clear();
            }

            r.totalRestartCount++;
            if (r.restartDelay == 0) {
                r.restartCount++;
                r.restartDelay = minDuration;
            } else {
                // If it has been a &quot;reasonably long time&quot; since the service
                // was started, then reset our restart duration back to
                // the beginning, so we don&#039;t infinitely increase the duration
                // on a service that just occasionally gets killed (which is
                // a normal case, due to process being killed to reclaim memory).
                if (now &gt; (r.restartTime+resetTime)) {
                    r.restartCount = 1;
                    r.restartDelay = minDuration;
                } else {
                    r.restartDelay *= SERVICE_RESTART_DURATION_FACTOR;
                    if (r.restartDelay &lt; minDuration) {
                        r.restartDelay = minDuration;
                    }
                }
            }

            r.nextRestartTime = now + r.restartDelay;

            // Make sure that we don&#039;t end up restarting a bunch of services
            // all at the same time.
            boolean repeat;
            do {
                repeat = false;
                for (int i=mRestartingServices.size()-1; i&gt;=0; i--) {
                    ServiceRecord r2 = mRestartingServices.get(i);
                    if (r2 != r &amp;&amp; r.nextRestartTime
                            &gt;= (r2.nextRestartTime-SERVICE_MIN_RESTART_TIME_BETWEEN)
                            &amp;&amp; r.nextRestartTime
                            &lt; (r2.nextRestartTime+SERVICE_MIN_RESTART_TIME_BETWEEN)) {
                        r.nextRestartTime = r2.nextRestartTime + SERVICE_MIN_RESTART_TIME_BETWEEN;
                        r.restartDelay = r.nextRestartTime - now;
                        repeat = true;
                        break;
                    }
                }
            } while (repeat);

        } else {
            // Persistent processes are immediately restarted, so there is no
            // reason to hold of on restarting their services.
            r.totalRestartCount++;
            r.restartCount = 0;
            r.restartDelay = 0;
            r.nextRestartTime = now;
        }

        if (!mRestartingServices.contains(r)) {
            r.createdFromFg = false;
            mRestartingServices.add(r);
            r.makeRestarting(mAm.mProcessStats.getMemFactorLocked(), now);
        }

        r.cancelNotification();

        mAm.mHandler.removeCallbacks(r.restarter);
        // 最关键的操作在这里，忘ActivityManagerService的handler里面post一个重启的Runnable
        // 这个东西前面启动过程创建ServiceRecord时有的，很简单就是一个ServiceRestarter，它里面保存了这个ServiceRecord本身
        // 重启的时候根据这个record就可以直接启动服务了
        mAm.mHandler.postAtTime(r.restarter, r.nextRestartTime);
        r.nextRestartTime = SystemClock.uptimeMillis() + r.restartDelay;
        Slog.w(TAG, &quot;Scheduling restart of crashed service &quot;
                + r.shortName + &quot; in &quot; + r.restartDelay + &quot;ms&quot;);
        EventLog.writeEvent(EventLogTags.AM_SCHEDULE_SERVICE_RESTART,
                r.userId, r.shortName, r.restartDelay);

        return canceled;
    }</pre>
<pre>    private class ServiceRestarter implements Runnable {
        private ServiceRecord mService;

        void setService(ServiceRecord service) {
            mService = service;
        }

        public void run() {
            synchronized(mAm) {
                //后面的事情就顺利成章了。
                performServiceRestartLocked(mService);
            }
        }
    }</pre>
<p>整个这个过程中，有好几个参数控制着是否需要重启，也定了很多参数的上限等等，这里单独列出来解释一下。</p>
<p>ServiceRecord.crashCount、ServiceRecord.StartItem.deliveryCount、ServiceRecord.StartItem.doneExecutingCount</p>
<p>crashCount顾名思义啊，就是crash的次数，这个在handleAppCrashLocked()中自增的，很明显每crash一次就会自增，没什么好说的</p>
<p>deliveryCount也很好理解，他是属于StartItem的，所以表示的是启动信息，是执行onStartCommand方法的次数，也就是外部startService的次数</p>
<p>doneExecutingCount跟deliveryCount还很有关联，类&#20284;的也是说的这个服务执行的次数，那么它们有什么区别呢？</p>
<p>还有两个标志位Service.START_FLAG_RETRY、Service.START_FLAG_REDELIVERY要一起看。这个在ActivesService.sendServiceArgsLocked()中可以看到。意思就是说这个服务是直接重启还是重新发送发送请求。</p>
<p>它们还是互斥的，这点在serviceDoneExecutingLocked()方法的START_REDELIVER_INTENT分支处理中可以得到结论，总的来说就是说onStartCommand返回START_STICKY是允许重启，而START_REDELIVER_INTENT会重新将上次的intent请求发送出去，服务中会重新接收到这个。</p>
<p>最后将在下篇论第三个问题</p>
<p>（三）、Service与其客户端的绑定如何实现，即跨进程调用问题。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 08:31:04 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/service/" title="service">service</a>, <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%8d%e5%8a%a1/" title="服务">服务</a>, <a href="https://www.biecuoliao.com/tag/%e9%87%8d%e5%90%af/" title="重启">重启</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android的服务（Service）（二）Service的自动重启问题的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n7WGX3.html" rel="bookmark">解决Android后台清理APP后，程序自动重启的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近解决了一个Android APP的bug,发现APP在被后台清理后,会自动重启.现象很奇怪,有的手机(HTC)后台清理后,程序必crash,而有的手机(小米)程序不会crash.查找问题时,发现HTC手机执行后台清理后,程序会自动重启,而小米手机则没有.猜想可能是小米手机内部做了处理,当执行后台清理后,对应的APP不会再重启了.不过问题在于,HTC手机后台清理,为什么会导致程序crash. Debug后发现,APP内部有一个Service,在Service的onStartCommand函数中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvlEP0.html" rel="bookmark">【ALearning】第五章 Android相关组件介绍&lpar;二&rpar;Service</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Service是Android中的四大组件之一,所以在Android开发过程中起到非常重要的作用.下面我们来看一下官方对Service的定义. A Service is an application component thatcan perform long-running operations in the background and does not provide auser interface. Another application component can start a se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jXGXg4.html" rel="bookmark">Qt浅谈之二十App自动重启及关闭子窗口（六种方法）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简介 最近因项目需求,Qt程序一旦检测到错误,要重新启动,自己是每次关闭主窗口的所有子窗口但有些模态框会出现问题,因此从网上总结了一些知识点,以备以后的应用. 二.详解 1.Qt结构 [cpp] view plaincopy int main(int argc, char *argv[]) { QApplication a(argc, argv); MyWidget w; MyDialog dialog;                      //新建MyDialog类对象 if(dia			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXLXZzM.html" rel="bookmark">Qt浅谈之二十App自动重启及关闭子窗口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简介 最近因项目需求,Qt程序一旦检测到错误,要重新启动,自己是每次关闭主窗口的所有子窗口但有些模态框会出现问题,因此从网上总结了一些知识点,以备以后的应用. 二.详解 1.Qt结构 [cpp] view plain copy int main(int argc, char *argv[]) { QApplication a(argc, argv); MyWidget w; MyDialog dialog;                      //新建MyDialog类对象 if(di			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDX2o7M.html" rel="bookmark">如何让Service自动重启而不被kill掉</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重写service的onStartCommand方法. @Override public int onStartCommand(Intent intent, int flags, int startId) { return START_STICKY; } 简单介绍下这个方法,在Android开发的过程中,每次调用startService(Intent)的时候,都会调用该Service对象的onStartCommand(Intent,int,int)方法,然后在onStartCommand方法中做			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDdjjwM.html" rel="bookmark">linux下监视进程 崩溃挂掉后自动重启的shell脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如何保证服务一直运行?如何保证即使服务挂掉了也能自动重启?在写服务程序时经常会碰到这样的问题.在Linux系统中,强大的shell就可以很灵活的处理这样的事务. 下面的shell通过一个while-do循环,用ps -ef|grep 检查loader进程是否正在运行,如果没有运行,则启动,这样就保证了崩溃挂掉的进程重新被及时启动. 必须注意两点: 1.ps |grep 一个进程时必须加上其路劲,否则容易grep到错误的结果: 2.必须用 -v 从结果中去除grep命令自身,否则结果非空. 复制代			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JbWJA4.html" rel="bookmark">Android Service 服务（二）&mdash;&mdash; BroadcastReceiver</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(转自:http://blog.csdn.net/ithomer/article/details/7365147) 一. BroadcastReceiver简介 BroadcastReceiver,用于异步接收广播Intent,广播Intent是通过调用Context.sendBroadcast()发送.BroadcastReceiver()接收. 广播Intent的发送是通过调用Context.sendBroadcast().Context.sendOrderedBroadcast().Con			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6p9jr3.html" rel="bookmark">深入剖析Android四大组件&lpar;二&rpar;&mdash;&mdash;Service服务之启动与绑定</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果说Activity通常都会提供一个用户界面UI的话,那么服务则不会提供任何用户界面,尽管如此,服务的作用仍然非常重要,它为我们提供了一种类似守护线程的手段来维持一些希望在退出以后仍然能持续运行的程序. 1.服务 既然服务的作用如此重要,本篇主要讲解如何使用服务和声明应用程序服务,下一节讲解怎么高效率的运用服务. ①何为服务 服务是一个应用程序组件,它在后台执行运行时间比较长的操作,不提供用户界面.它可以被其他应用程序组件启动或停止,并且当用户切换到另一个应用程序时,它仍然在后台持续的运行.另			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AZQZ5M.html" rel="bookmark">Android Bound Service&lpar;二&rpar; ----- Using AIDL</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				refs: http://developer.android.com/guide/components/aidl.html AIDL(Android Interface Definition Language) 就像其它接口定义语言一样.它使你可以定义服务端及客户端程序的接口,以达到跨进程沟通( IPC )的目的. 注意: 1.在多进程多线程的情况下,我们才使用 AIDL 2.单一进程时,使用实现 Binder 类的方式定义接口 3.如果只有跨进程,但不需処理多线程的情况,请使用 Messeng			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9ME6qD0.html" rel="bookmark" class="title">求4位数字的回文数</a>
					<div>
						第一种:利用逆序数字是否和原来的数字相等 #include&lt;stdio.h&gt; int main() { int i,key,sum;//i循环变量1000~9999的数字,key保存i值后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBXGy3.html" rel="bookmark" class="title">MySql学习笔记（二）</a>
					<div>
						MySql的安装配置与卸载: 安装:(1)将MySql的绿色版免安装包放到D盘,命令行进入mysql绿色版解压缩后的bin目录:cd D:\mysql-5.6.35-win32\bin --此处提供绿 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dZQr4.html" rel="bookmark" class="title">vue1与vue2的路由 以及vue2项目大概了解</a>
					<div>
						vue1的路由 1.设置根组件  Vue.extend() 2.设置局部组件  Vue.extend({template:&quot;/home&quot;}) 3.实例化路由   var route ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dGJBM.html" rel="bookmark" class="title">软件工程之Spring音乐播放界面C&num;编写细节</a>
					<div>
						由于小组成员已经完成软件的详细设计说明书,在这里只具体说明软件程序的细节编写,以免重复. 歌曲的播放采用VS自带的axWindowsMediaPlayer插件,所以程序中涉及到许多该插件的使用.Ctl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5VJg0.html" rel="bookmark" class="title">Backbone&period;js</a>
					<div>
						http://backbonejs.org/#introduction Backbone.js gives structure to web applications      by providin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awyAQ4.html" rel="bookmark" class="title">【转载】linux环境下tcpdump源代码分析</a>
					<div>
						linux环境下tcpdump源代码分析 原文时间 2013-10-11 13:13:02   原文链接   主题 Tcpdump 作者:韩大卫 @ 吉林师范大学 tcpdump.c 是tcpdump ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjDeB3.html" rel="bookmark" class="title">学习ASP&period;NET MVC5框架揭秘笔记-ASP&period;NET MVC是如何运行的（四）</a>
					<div>
						Action的执行 作为Controller的基类ControllerBase,它的Execute方法主要作用在于执行目标Action方法.如果目标Action方法返回一个ActionResult对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JzbjV4.html" rel="bookmark" class="title">追不上的手</a>
					<div>
						虽不是用年来计算的日子,但那不曾被忘记的每一天都是我对你的迷恋:不曾被每天的忙碌所掩盖:不曾被晨风和夕阳所吹过:也不曾被所有难以开口诉说所省略过......只是为了一张洁白的信笺纸记下那些不会被忘记或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8V6G0.html" rel="bookmark" class="title">python基础-list</a>
					<div>
						list是一种有序的集合,可以随时添加和删除其中的元素. 知识点: 增 append()..insert() 删 .pop(1) 查 classmates[-1] 改 classmates[1] =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGXvp0.html" rel="bookmark" class="title">java时间段分成小段存储</a>
					<div>
						package testThread; import java.text.ParseException; import java.text.SimpleDateFormat; import java. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JY9RV3.html" rel="bookmark" class="title">perl一次读取多行文本的策略</a>
					<div>
						在处理文本时,常常遇到这样的情况:就是我们需要把两行文本做一个比较,然后选择性输出.而在while(&lt;FILEHAND&gt;){do something}程序块中默认只能一次读取一行.笔者在这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jnYo70.html" rel="bookmark" class="title">数论--乘法逆元</a>
					<div>
						乘法逆元 定义: 满足a*k≡1 (mod p)的k值就是a关于p的乘法逆元. 为什么要有乘法逆元呢?当我们要求(a/b) mod p的值,且a很大,无法直接求得a/b的值时,我们就要用到乘法逆元.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQ898M.html" rel="bookmark" class="title">&lbrack;cocos2dx&rsqb;cocos2dx-lua中的框架MVC</a>
					<div>
						MVC简介 MVC,即Model View Controller.Model(模型),一般负责数据的处理:View(视图),一般负责界面的显示:Controller(控制器),一般负责前端的逻辑处理. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBppg3.html" rel="bookmark" class="title">jQuery和JS原生方法对比</a>
					<div>
						input标签讲解 &lt;input/&gt;作为按钮的type属性:button.submit(后面会有二者对比分析) (交互时的效果跟浏览器以及操作系统相关) &lt;input/&gt;的局限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOvDDM.html" rel="bookmark" class="title">用jenkins搭建android自动打包环境</a>
					<div>
						这里假设你已经搭建了jenkins的环境.否则,请阅读我的另一篇文章: http://my.oschina.net/u/930967/blog/298980 其实那个文章里面有用的就两句话的事儿,还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6jlb3.html" rel="bookmark" class="title">菜鸟要做架构师（二）&mdash;&mdash;java性能优化之for循环</a>
					<div>
						完成同样的功能,用不同的代码来实现,性能上可能会有比较大的差别,所以对于一些性能敏感的模块来说,对代码进行一定的优化还是很有必要的.今天就来说一下java代码优化的事情,今天主要聊一下对于for(wh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JOQJAM.html" rel="bookmark" class="title">Spring Boot 中文乱码解决</a>
					<div>
						第一步,约定传参编码格式 不管是使用httpclient,还是okhttp,都要设置传参的编码,为了统一,这里全部设置为utf-8 第二步,修改application.properties文件 增加如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXwAW3.html" rel="bookmark" class="title">Stream computing</a>
					<div>
						在传统的数据处理流程中,总是先收集数据,然后将数据放到Database中,人们需要的时候通过DB对数据做query,得到答案.这样的一个流程隐含了两个前提:1. data is old.当人们对DB做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35pqWn0.html" rel="bookmark" class="title">Android Studio2&period;0引入so文件（亲测）</a>
					<div>
						转载自:http://blog.csdn.net/u011421608/article/details/51338482 步骤如下: 1.如图,直接将so文件放在libs目录下: 2.在build.g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kwd1j0.html" rel="bookmark" class="title">标准键盘-特殊符号-英文读法&plus;希腊字母表</a>
					<div>
						! 叹号 exclamation mark/bang ? 问号 question mark , 逗号 comma . 点号 dot/period/point : 冒号 colon ; 分号 semic ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
